## openblas 0.2.5

=== Makefile ===
TOPDIR	= .
include ./Makefile.system

BLASDIRS = interface driver/level2 driver/level3 driver/others

ifneq ($(DYNAMIC_ARCH), 1)
BLASDIRS += kernel 
endif

ifdef UTEST_CHECK
SANITY_CHECK = 1
endif

ifdef SANITY_CHECK
BLASDIRS += reference
endif

ifndef PREFIX
PREFIX = /opt/OpenBLAS
endif

SUBDIRS	= $(BLASDIRS)
ifneq ($(NO_LAPACK), 1)
SUBDIRS	+= lapack
endif

SUBDIRS_ALL = $(SUBDIRS) test ctest utest exports benchmark ../laswp ../bench

.PHONY : all libs netlib test ctest shared install
.NOTPARALLEL : all libs prof lapack-test install

all :: libs netlib tests shared
	@echo
	@echo " OpenBLAS build complete."
	@echo
	@echo "  OS               ... $(OSNAME)             "
	@echo "  Architecture     ... $(ARCH)               "
ifndef BINARY64
	@echo "  BINARY           ... 32bit                 "
else
	@echo "  BINARY           ... 64bit                 "
endif
ifdef INTERFACE64
	@echo "  Use 64 bits int    (equivalent to \"-i8\" in Fortran)      "
endif
	@echo "  C compiler       ... $(C_COMPILER)  (command line : $(CC))"
	@echo "  Fortran compiler ... $(F_COMPILER)  (command line : $(FC))"
ifneq ($(OSNAME), AIX)
	@echo -n "  Library Name     ... $(LIBNAME)"
else
	@echo "  Library Name     ... $(LIBNAME)"
endif

ifndef SMP
	@echo " (Single threaded)  "
else
	@echo " (Multi threaded; Max num-threads is $(NUM_THREADS))"
endif

ifeq ($(USE_OPENMP), 1)
	@echo
	@echo " Use OpenMP in the multithreading. Becasue of ignoring OPENBLAS_NUM_THREADS and GOTO_NUM_THREADS flags, "
	@echo " you should use OMP_NUM_THREADS environment variable to control the number of threads."
	@echo
endif

ifeq ($(OSNAME), Darwin)
	@echo "WARNING: If you plan to use the dynamic library $(LIBDYNNAME), you must run:"
	@echo
	@echo "\"make PREFIX=/your_installation_path/ install\"."
	@echo
	@echo "(or set PREFIX in Makefile.rule and run make install."
	@echo "If you want to move the .dylib to a new location later, make sure you change"
	@echo "the internal name of the dylib with:"
	@echo
	@echo "install_name_tool -id /new/absolute/path/to/$(LIBDYNNAME) $(LIBDYNNAME)"
endif
	@echo
	@echo "To install the library, you can run \"make PREFIX=/path/to/your/installation install\"."
	@echo

shared :
ifndef NO_SHARED
ifeq ($(OSNAME), Linux)
	$(MAKE) -C exports so
	-ln -fs $(LIBSONAME) $(LIBPREFIX).so
	-ln -fs $(LIBSONAME) $(LIBPREFIX).so.$(MAJOR_VERSION)
endif
ifeq ($(OSNAME), FreeBSD)
	$(MAKE) -C exports so
	-ln -fs $(LIBSONAME) $(LIBPREFIX).so
endif
ifeq ($(OSNAME), NetBSD)
	$(MAKE) -C exports so
	-ln -fs $(LIBSONAME) $(LIBPREFIX).so
endif
ifeq ($(OSNAME), Darwin)
	$(MAKE) -C exports dyn
	-ln -fs $(LIBDYNNAME) $(LIBPREFIX).dylib
endif
ifeq ($(OSNAME), WINNT)
	$(MAKE) -C exports dll
endif
ifeq ($(OSNAME), CYGWIN_NT)
	$(MAKE) -C exports dll
endif
endif

tests :
ifndef NOFORTRAN
ifndef TARGET
ifndef CROSS
	touch $(LIBNAME)
ifndef NO_FBLAS
	$(MAKE) -C test all
ifdef UTEST_CHECK
	$(MAKE) -C utest all
endif
endif
ifndef NO_CBLAS
	$(MAKE) -C ctest all
endif
endif
endif
endif

libs :
ifeq ($(CORE), UNKOWN)
	$(error OpenBLAS: Detecting CPU failed. Please set TARGET explicitly, e.g. make TARGET=your_cpu_target. Please read README for the detail.)
endif
ifeq ($(NOFORTRAN), 1)
	$(error OpenBLAS: Detecting fortran compiler failed. Please install fortran compiler, e.g. gfortran, ifort, openf90.)
endif
	-ln -fs $(LIBNAME) $(LIBPREFIX).$(LIBSUFFIX)
	for d in $(SUBDIRS) ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d $(@F) || exit 1 ; \
	fi; \
	done
#Save the config files for installation
	cp Makefile.conf Makefile.conf_last
	cp config.h config_last.h
ifdef QUAD_PRECISION
	echo "#define QUAD_PRECISION">> config_last.h
endif
ifeq ($(EXPRECISION), 1)
	echo "#define EXPRECISION">> config_last.h
endif
## 
ifeq ($(DYNAMIC_ARCH), 1)
	  $(MAKE) -C kernel commonlibs || exit 1
	for d in $(DYNAMIC_CORE) ; \
	do  $(MAKE) GOTOBLAS_MAKEFILE= -C kernel TARGET_CORE=$$d kernel || exit 1 ;\
	done
	echo DYNAMIC_ARCH=1 >> Makefile.conf_last
endif
	touch lib.grd

prof : prof_blas prof_lapack

prof_blas :
	ln -fs $(LIBNAME_P) $(LIBPREFIX)_p.$(LIBSUFFIX)
	for d in $(SUBDIRS) ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d prof || exit 1 ; \
	fi; \
	done
ifeq ($(DYNAMIC_ARCH), 1)
	  $(MAKE) -C kernel commonprof || exit 1
endif

blas :
	ln -fs $(LIBNAME) $(LIBPREFIX).$(LIBSUFFIX)
	for d in $(BLASDIRS) ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d libs || exit 1 ; \
	fi; \
	done

hpl : 
	ln -fs $(LIBNAME) $(LIBPREFIX).$(LIBSUFFIX)
	for d in $(BLASDIRS) ../laswp exports ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d $(@F) || exit 1 ; \
	fi; \
	done
ifeq ($(DYNAMIC_ARCH), 1)
	  $(MAKE) -C kernel commonlibs || exit 1
	for d in $(DYNAMIC_CORE) ; \
	do  $(MAKE) GOTOBLAS_MAKEFILE= -C kernel TARGET_CORE=$$d kernel || exit 1 ;\
	done
endif

hpl_p :
	ln -fs $(LIBNAME_P) $(LIBPREFIX)_p.$(LIBSUFFIX)
	for d in $(SUBDIRS) ../laswp exports ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d $(@F) || exit 1 ; \
	fi; \
	done

ifeq ($(NO_LAPACK), 1)
netlib : 

else
netlib : lapack-3.4.2 patch.for_lapack-3.4.2 $(NETLIB_LAPACK_DIR)/make.inc
ifndef NOFORTRAN
	-@$(MAKE) -C $(NETLIB_LAPACK_DIR) lapacklib
endif
ifndef NO_LAPACKE
	-@$(MAKE) -C $(NETLIB_LAPACK_DIR) lapackelib
endif
endif

prof_lapack : lapack-3.4.2 $(NETLIB_LAPACK_DIR)/make.inc
	-@$(MAKE) -C $(NETLIB_LAPACK_DIR) lapack_prof

$(NETLIB_LAPACK_DIR)/make.inc :
ifndef NOFORTRAN
	-@echo "FORTRAN     = $(FC)" > $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "OPTS        = $(FFLAGS)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "POPTS       = $(FPFLAGS)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "NOOPT       = $(FFLAGS) -O0" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "PNOOPT      = $(FPFLAGS) -O0" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "LOADOPTS    = $(FFLAGS) $(EXTRALIB)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "CC          = $(CC)" >> $(NETLIB_LAPACK_DIR)/make.inc
ifdef INTERFACE64
	-@echo "CFLAGS      = $(CFLAGS) -DHAVE_LAPACK_CONFIG_H  -DLAPACK_ILP64" >> $(NETLIB_LAPACK_DIR)/make.inc
else
	-@echo "CFLAGS      = $(CFLAGS)" >> $(NETLIB_LAPACK_DIR)/make.inc
endif
	-@echo "ARCH        = $(AR)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "ARCHFLAGS   = -ru" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "RANLIB      = $(RANLIB)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "LAPACKLIB   = ../$(LIBNAME)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "LAPACKELIB  = ../$(LIBNAME)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "LAPACKLIB_P = ../$(LIBNAME_P)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "SUFFIX      = $(SUFFIX)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "PSUFFIX     = $(PSUFFIX)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@echo "CEXTRALIB   = $(EXTRALIB)" >> $(NETLIB_LAPACK_DIR)/make.inc
	-@cat  make.inc >> $(NETLIB_LAPACK_DIR)/make.inc
endif

lapack-3.4.2 : lapack-3.4.2.tgz
ifndef NOFORTRAN
ifndef NO_LAPACK
	@if test `$(MD5SUM) lapack-3.4.2.tgz | $(AWK) '{print $$1}'` = 61bf1a8a4469d4bdb7604f5897179478; then \
		echo $(TAR) zxf $< ;\
		$(TAR) zxf $< && (cd $(NETLIB_LAPACK_DIR); $(PATCH) -p1 < ../patch.for_lapack-3.4.2) ;\
		rm -f $(NETLIB_LAPACK_DIR)/lapacke/make.inc ;\
	else \
		rm -rf $(NETLIB_LAPACK_DIR) ;\
		echo "	Cannot download lapack-3.4.2.tgz or the MD5 check sum is wrong (Please use orignal)."; \
		exit 1; \
	fi
endif
endif

LAPACK_URL=http://www.netlib.org/lapack/lapack-3.4.2.tgz

lapack-3.4.2.tgz :
ifndef NOFORTRAN
#http://stackoverflow.com/questions/7656425/makefile-ifeq-logical-or
ifeq ($(OSNAME), $(filter $(OSNAME),Darwin NetBSD))
	curl -O $(LAPACK_URL)
else
ifeq ($(OSNAME), FreeBSD)
	fetch $(LAPACK_URL)
else
	wget $(LAPACK_URL)
endif
endif
endif

large.tgz : 
ifndef NOFORTRAN
	-wget http://www.netlib.org/lapack/timing/large.tgz
endif

timing.tgz :
ifndef NOFORTRAN
	-wget http://www.netlib.org/lapack/timing/timing.tgz
endif

lapack-timing : lapack-3.4.2 large.tgz timing.tgz
ifndef NOFORTRAN
	(cd $(NETLIB_LAPACK_DIR); $(TAR) zxf ../timing.tgz TIMING)
	(cd $(NETLIB_LAPACK_DIR)/TIMING; $(TAR) zxf ../../large.tgz )
	make -C $(NETLIB_LAPACK_DIR) tmglib
	make -C $(NETLIB_LAPACK_DIR)/TIMING
endif


lapack-test :
	$(MAKE) -C $(NETLIB_LAPACK_DIR) tmglib
	$(MAKE) -C $(NETLIB_LAPACK_DIR)/TESTING xeigtstc xeigtstd xeigtsts xeigtstz xlintstc xlintstd xlintstds xlintsts xlintstz xlintstzc
	@rm	-f $(NETLIB_LAPACK_DIR)/TESTING/*.out
	$(MAKE) -j 1 -C $(NETLIB_LAPACK_DIR)/TESTING
	$(GREP) failed $(NETLIB_LAPACK_DIR)/TESTING/*.out

dummy :

install :
	$(MAKE) -f Makefile.install install

clean ::
	@for d in $(SUBDIRS_ALL) ; \
	do if test -d $$d; then \
	  $(MAKE) -C $$d $(@F) || exit 1 ; \
	fi; \
	done
#ifdef DYNAMIC_ARCH
	@$(MAKE) -C kernel clean
#endif
	@$(MAKE) -C reference clean
	@rm -f *.$(LIBSUFFIX) *.so *~ *.exe getarch getarch_2nd *.dll *.lib *.$(SUFFIX) *.dwf $(LIBPREFIX).$(LIBSUFFIX) $(LIBPREFIX)_p.$(LIBSUFFIX) $(LIBPREFIX).so.$(MAJOR_VERSION) *.lnk myconfig.h
	@rm -f Makefile.conf config.h Makefile_kernel.conf config_kernel.h st* *.dylib
	@if test -d $(NETLIB_LAPACK_DIR); then \
	echo deleting $(NETLIB_LAPACK_DIR); \
	rm -rf $(NETLIB_LAPACK_DIR) ;\
	fi
	@rm -f *.grd Makefile.conf_last config_last.h
	@echo Done.

=== ctest/Makefile ===
#
# The Makefile compiles c wrappers and testers for CBLAS.  
#

TOPDIR = ..
include $(TOPDIR)/Makefile.system

override CFLAGS += -DADD$(BU) -DCBLAS

LIB = $(TOPDIR)/$(LIBNAME)

stestl1o = c_sblas1.o

stestl2o = c_sblas2.o c_s2chke.o auxiliary.o c_xerbla.o constant.o

stestl3o = c_sblas3.o c_s3chke.o auxiliary.o c_xerbla.o constant.o

dtestl1o = c_dblas1.o

dtestl2o = c_dblas2.o c_d2chke.o auxiliary.o c_xerbla.o constant.o

dtestl3o = c_dblas3.o c_d3chke.o auxiliary.o c_xerbla.o constant.o

ctestl1o = c_cblas1.o

ctestl2o = c_cblas2.o c_c2chke.o auxiliary.o c_xerbla.o constant.o

ctestl3o = c_cblas3.o c_c3chke.o auxiliary.o c_xerbla.o constant.o

ztestl1o = c_zblas1.o 

ztestl2o = c_zblas2.o c_z2chke.o auxiliary.o c_xerbla.o constant.o

ztestl3o = c_zblas3.o c_z3chke.o auxiliary.o c_xerbla.o constant.o

all :: all1 all2 all3 

all1: xscblat1 xdcblat1 xccblat1 xzcblat1
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat1
	OMP_NUM_THREADS=2 ./xdcblat1
	OMP_NUM_THREADS=2 ./xccblat1
	OMP_NUM_THREADS=2 ./xzcblat1
else
	OPENBLAS_NUM_THREADS=2 ./xscblat1
	OPENBLAS_NUM_THREADS=2 ./xdcblat1
	OPENBLAS_NUM_THREADS=2 ./xccblat1
	OPENBLAS_NUM_THREADS=2 ./xzcblat1
endif

all2: xscblat2 xdcblat2 xccblat2 xzcblat2
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat2 < sin2
	OMP_NUM_THREADS=2 ./xdcblat2 < din2
	OMP_NUM_THREADS=2 ./xccblat2 < cin2
	OMP_NUM_THREADS=2 ./xzcblat2 < zin2
else
	OPENBLAS_NUM_THREADS=2 ./xscblat2 < sin2
	OPENBLAS_NUM_THREADS=2 ./xdcblat2 < din2
	OPENBLAS_NUM_THREADS=2 ./xccblat2 < cin2
	OPENBLAS_NUM_THREADS=2 ./xzcblat2 < zin2
endif

all3: xscblat3 xdcblat3 xccblat3 xzcblat3
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./xscblat3 < sin3
	OMP_NUM_THREADS=2 ./xdcblat3 < din3
	OMP_NUM_THREADS=2 ./xccblat3 < cin3
	OMP_NUM_THREADS=2 ./xzcblat3 < zin3
else
	OPENBLAS_NUM_THREADS=2 ./xscblat3 < sin3
	OPENBLAS_NUM_THREADS=2 ./xdcblat3 < din3
	OPENBLAS_NUM_THREADS=2 ./xccblat3 < cin3
	OPENBLAS_NUM_THREADS=2 ./xzcblat3 < zin3
endif

clean ::
	rm -f x* 

FLDFLAGS = $(FFLAGS:-fPIC=)
CEXTRALIB = 

# Single real
xscblat1: $(stestl1o) c_sblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat1 c_sblat1.o $(stestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xscblat2: $(stestl2o) c_sblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat2 c_sblat2.o $(stestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xscblat3: $(stestl3o) c_sblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xscblat3 c_sblat3.o $(stestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
# Double real
xdcblat1: $(dtestl1o) c_dblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat1 c_dblat1.o $(dtestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xdcblat2: $(dtestl2o) c_dblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat2 c_dblat2.o $(dtestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xdcblat3: $(dtestl3o) c_dblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xdcblat3 c_dblat3.o $(dtestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
 
# Single complex
xccblat1: $(ctestl1o) c_cblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat1 c_cblat1.o $(ctestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xccblat2: $(ctestl2o) c_cblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat2 c_cblat2.o $(ctestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xccblat3: $(ctestl3o) c_cblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xccblat3 c_cblat3.o $(ctestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)

# Double complex 
xzcblat1: $(ztestl1o) c_zblat1.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat1 c_zblat1.o $(ztestl1o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xzcblat2: $(ztestl2o) c_zblat2.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat2 c_zblat2.o $(ztestl2o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
xzcblat3: $(ztestl3o) c_zblat3.o $(TOPDIR)/$(LIBNAME)
	$(FC) $(FLDFLAGS) -o xzcblat3 c_zblat3.o $(ztestl3o) $(LIB) $(EXTRALIB) $(CEXTRALIB)
   
include $(TOPDIR)/Makefile.tail

=== exports/Makefile ===
TOPDIR	= ..

include ../Makefile.system

ifndef EXPRECISION
EXPRECISION	= 0
endif

ifndef NO_CBLAS
NO_CBLAS	= 0
endif

ifndef NO_LAPACK
NO_LAPACK	= 0
endif

ifndef NO_LAPACKE
NO_LAPACKE	= 0
endif

ifeq ($(OSNAME), WINNT)
ifeq ($(F_COMPILER), GFORTRAN)
EXTRALIB += -lgfortran
endif
endif

ifeq ($(OSNAME), CYGWIN_NT)
ifeq ($(F_COMPILER), GFORTRAN)
EXTRALIB += -lgfortran
endif
endif

all::

libs::

prof::

hpl:: libgoto_hpl.$(LIBSUFFIX)

hpl_p:: libgoto_hpl_p.$(LIBSUFFIX)

libgoto_hpl.$(LIBSUFFIX) : ../$(LIBNAME)
	rm -f $(@F)
	$(LD) -r $(LDFLAGS) -o goto.$(SUFFIX) --whole-archive $< --no-whole-archive
	$(AR) cq $(@F) goto.$(SUFFIX)
	$(RANLIB) libgoto_hpl.$(LIBSUFFIX)

libgoto_hpl_p.$(LIBSUFFIX) :  ../$(LIBNAME_P)
	rm -f $(@F)
	$(LD) -r  $(LDFLAGS) -o goto.$(PSUFFIX)  --whole-archive $< --no-whole-archive
	$(AR) cq $(@F) goto.$(PSUFFIX)
	$(RANLIB) libgoto_hpl_p.$(LIBSUFFIX)

libgoto_hpl.dll : libgoto_hpl.$(LIBSUFFIX) dllinit.$(SUFFIX) libgoto_hpl.def
	$(DLLWRAP) -o $(@F) --def libgoto_hpl.def --entry _dllinit -s dllinit.$(SUFFIX) --dllname libgoto_hpl.dll libgoto_hpl.$(LIBSUFFIX)
	lib /machine:X64 /def:libgoto_hpl.def

dyn : $(LIBDYNNAME)

zip : dll
	zip $(LIBZIPNAME) $(LIBDLLNAME) $(LIBNAME)

dll  : ../$(LIBDLLNAME)
#libgoto2.dll

dll2 : libgoto2_shared.dll

# On Windows, we only generate a DLL without a version suffix.  This is because
# applications which link against the dynamic library reference a fixed DLL name
# in their import table.  By instead using a stable name it is possible to
# upgrade between library versions, without needing to re-link an application.
# For more details see: https://github.com/xianyi/OpenBLAS/issues/127.
../$(LIBDLLNAME) : ../$(LIBNAME) libopenblas.def dllinit.$(SUFFIX)
	$(RANLIB) ../$(LIBNAME)
ifeq ($(BINARY32), 1)
	$(DLLWRAP) -o ../$(LIBDLLNAME) --def libopenblas.def \
	--entry _dllinit@12 -s dllinit.$(SUFFIX) --dllname $(@F) ../$(LIBNAME) $(EXTRALIB)
	-lib /machine:i386 /def:libopenblas.def
else
	$(DLLWRAP) -o ../$(LIBDLLNAME) --def libopenblas.def \
	--entry $(FU)dllinit    -s dllinit.$(SUFFIX) --dllname $(@F) ../$(LIBNAME) $(EXTRALIB)
	-lib /machine:X64 /def:libopenblas.def 
endif

libgoto2_shared.dll : ../$(LIBNAME) libgoto2_shared.def
	$(CC) $(CFLAGS) libgoto2_shared.def -shared -o $(@F) \
	-Wl,--whole-archive ../$(LIBNAME) -Wl,--no-whole-archive \
	-Wl,--out-implib,libgoto2_shared.lib $(FEXTRALIB)

libopenblas.def : gensymbol
	perl ./gensymbol win2k    $(ARCH) dummy $(EXPRECISION) $(NO_CBLAS) $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

libgoto2_shared.def : gensymbol
	perl ./gensymbol win2k    $(ARCH) dummy $(EXPRECISION) $(NO_CBLAS) $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

libgoto_hpl.def : gensymbol
	perl ./gensymbol win2khpl $(ARCH) dummy $(EXPRECISION) $(NO_CBLAS) $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

$(LIBDYNNAME) : ../$(LIBNAME) osx.def
	$(CC) $(CFLAGS) -all_load -headerpad_max_install_names -install_name $(CURDIR)/../$(LIBDYNNAME) -dynamiclib -o ../$(LIBDYNNAME) $< -Wl,-exported_symbols_list,osx.def  $(FEXTRALIB)

symbol.$(SUFFIX) : symbol.S
	$(CC) $(CFLAGS) -c -o $(@F) $^

dllinit.$(SUFFIX) : dllinit.c
	$(CC) $(CFLAGS) -c -o $(@F) -s $<

ifeq ($(OSNAME), Linux)

so : ../$(LIBSONAME)

../$(LIBSONAME) : ../$(LIBNAME) linux.def linktest.c
	$(CC) $(CFLAGS) -shared -o ../$(LIBSONAME) \
	-Wl,--whole-archive ../$(LIBNAME) -Wl,--no-whole-archive \
	-Wl,--retain-symbols-file=linux.def -Wl,-soname,$(LIBPREFIX).so.$(MAJOR_VERSION) $(EXTRALIB)
	$(CC) $(CFLAGS) -w -o linktest linktest.c ../$(LIBSONAME) $(FEXTRALIB) && echo OK.
	rm -f linktest

endif

#http://stackoverflow.com/questions/7656425/makefile-ifeq-logical-or
ifeq ($(OSNAME), $(filter $(OSNAME),FreeBSD NetBSD))

so : ../$(LIBSONAME)

../$(LIBSONAME) : ../$(LIBNAME) linux.def linktest.c
	$(CC) $(CFLAGS)  -shared -o ../$(LIBSONAME) \
	-Wl,--whole-archive ../$(LIBNAME) -Wl,--no-whole-archive \
	-Wl,--retain-symbols-file=linux.def $(FEXTRALIB) $(EXTRALIB)
	$(CC) $(CFLAGS) -w -o linktest linktest.c ../$(LIBSONAME) $(FEXTRALIB) && echo OK.
	rm -f linktest

endif

ifeq ($(OSNAME), OSF1)

so : ../$(LIBSONAME)

../$(LIBSONAME) :
	$(CC) -shared -o ../$(LIBSONAME) ../$(LIBNAME)
endif

ifeq ($(OSNAME), SunOS)

so : ../$(LIBSONAME)
	$(CC) $(CFLAGS)  -shared -o ../$(LIBSONAME) \
	-Wl,--whole-archive ../$(LIBNAME) -Wl,--no-whole-archive $(EXTRALIB)
	$(CC) $(CFLAGS) -w -o linktest linktest.c ../$(LIBSONAME) $(FEXTRALIB) && echo OK.
	rm -f linktest

endif

ifeq ($(OSNAME), AIX)

ifeq ($(COMPILER_F77), xlf)

goto32.$(SUFFIX) : ../$(LIBNAME) aix.def
	ld -o $(@F) ../$(LIBNAME) -bE:aix.def -bM:SRE -bnoexpall -bnoentry -L$(HOME)/misc/lib -lxlf90 -lc -lm  -lpthread

goto64.$(SUFFIX) : ../$(LIBNAME) aix.def
	ld -b64 -o $(@F) ../$(LIBNAME) -bE:aix.def -bM:SRE -bnoexpall -bnoentry -L$(HOME)/misc/lib/ppc64 -lxlf90 -lc -lm -lpthread
else
goto32.$(SUFFIX) : ../$(LIBNAME) aix.def
	ld -o $(@F) ../$(LIBNAME) -bE:aix.def -bM:SRE -bnoexpall -bnoentry -L$(HOME)/misc/lib -lg2c -lc -lm 

goto64.$(SUFFIX) : ../$(LIBNAME) aix.def
	ld -b64 -o $(@F) ../$(LIBNAME) -bE:aix.def -bM:SRE -bnoexpall -bnoentry -L$(HOME)/misc/lib/ppc64 -lg2c -lc -lm 
endif
endif

static : ../$(LIBNAME)
	$(LD) $(LDFLAGS) -r -o goto.$(SUFFIX) \
	--whole-archive ../$(LIBNAME) --no-whole-archive
	rm -f ../$(LIBNAME)
	$(AR) -cq ../$(LIBNAME) goto.$(SUFFIX)
	rm -f goto.$(SUFFIX)

linux.def : gensymbol ../Makefile.system ../getarch.c
	perl ./gensymbol linux $(ARCH) $(BU) $(EXPRECISION) $(NO_CBLAS)  $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

osx.def : gensymbol ../Makefile.system ../getarch.c
	perl ./gensymbol osx $(ARCH) $(BU) $(EXPRECISION) $(NO_CBLAS)  $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

aix.def : gensymbol ../Makefile.system ../getarch.c
	perl ./gensymbol aix $(ARCH) $(BU) $(EXPRECISION) $(NO_CBLAS)  $(NO_LAPACK) $(NO_LAPACKE) > $(@F)

symbol.S : gensymbol
	perl ./gensymbol win2kasm noarch dummy $(EXPRECISION) $(NO_CBLAS)  $(NO_LAPACK) $(NO_LAPACKE) > symbol.S

test : linktest.c
	$(CC) $(CFLAGS) -w -o linktest linktest.c ../$(LIBSONAME) -lm && echo OK.
	rm -f linktest

linktest.c : gensymbol ../Makefile.system ../getarch.c
	perl ./gensymbol linktest  $(ARCH) $(BU) $(EXPRECISION) $(NO_CBLAS) $(NO_LAPACK) $(NO_LAPACKE) > linktest.c

clean ::
	@rm -f *.def *.dylib __.SYMDEF*

include ../Makefile.tail

=== driver/others/Makefile ===
TOPDIR	= ../..
include ../../Makefile.system

COMMONOBJS	 = memory.$(SUFFIX) xerbla.$(SUFFIX) c_abs.$(SUFFIX) z_abs.$(SUFFIX) openblas_set_num_threads.$(SUFFIX)

COMMONOBJS	+= slamch.$(SUFFIX) slamc3.$(SUFFIX) dlamch.$(SUFFIX)  dlamc3.$(SUFFIX)

ifdef SMP
COMMONOBJS	+= blas_server.$(SUFFIX) divtable.$(SUFFIX) blasL1thread.$(SUFFIX) 
ifndef NO_AFFINITY
COMMONOBJS	+= init.$(SUFFIX) 
endif
endif

# COMMONOBJS	+=  info.$(SUFFIX)

ifeq ($(DYNAMIC_ARCH), 1)
COMMONOBJS	+=  dynamic.$(SUFFIX)
else
COMMONOBJS	+=  parameter.$(SUFFIX)
endif

ifdef EXPRECISION
COMMONOBJS	+= x_abs.$(SUFFIX) qlamch.$(SUFFIX) qlamc3.$(SUFFIX)
endif

ifdef QUAD_PRECISION
COMMONOBJS	+= addx.$(SUFFIX) mulx.$(SUFFIX)
endif

ifeq ($(OSNAME), CYGWIN_NT)
ifeq ($(C_COMPILER), PGI)
# COMMONOBJS	+= __builtin_stinit.$(SUFFIX)
endif
endif

ifdef USE_CUDA
COMMONOBJS	+= cuda_init.$(SUFFIX)
endif

ifdef FUNCTION_PROFILE
COMMONOBJS	+= profile.$(SUFFIX)
endif

LIBOTHERS = libothers.$(LIBSUFFIX)

ifeq ($(CORE), PPC440)
MEMORY = memory_qalloc.c
endif

ifndef MEMORY
MEMORY = memory.c
endif

ifeq ($(USE_OPENMP), 1)
BLAS_SERVER = blas_server_omp.c
else
ifeq ($(OSNAME), WINNT)
BLAS_SERVER = blas_server_win32.c 
endif
ifeq ($(OSNAME), CYGWIN_NT)
BLAS_SERVER = blas_server_win32.c 
endif
ifeq ($(OSNAME), Interix)
BLAS_SERVER = blas_server_win32.c 
endif
endif

ifndef BLAS_SERVER
BLAS_SERVER = blas_server.c
endif

ifeq ($(DYNAMIC_ARCH), 1)
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic.$(SUFFIX)
else
HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) parameter.$(SUFFIX)
endif

xerbla.$(SUFFIX) : xerbla.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

dynamic.$(SUFFIX) : dynamic.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

dynamic.$(PSUFFIX) : dynamic.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

parameter.$(SUFFIX) : parameter.c ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

init.$(SUFFIX) : init.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

profile.$(SUFFIX) : profile.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

memory.$(SUFFIX) : $(MEMORY) ../../common.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

blas_server.$(SUFFIX) : $(BLAS_SERVER) ../../common.h ../../common_thread.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

openblas_set_num_threads.$(SUFFIX) : openblas_set_num_threads.c
	$(CC) $(CFLAGS) -c $< -o $(@F)

blasL1thread.$(SUFFIX) : blas_l1_thread.c ../../common.h ../../common_thread.h
	$(CC) $(CFLAGS) -c $< -o $(@F)

cuda_init.$(SUFFIX) : cuda_init.c
	$(CUCC) $(COMMON_OPT) -I$(TOPDIR) $(CUFLAGS) -DCNAME=$(*F) -c $< -o $(@F)

c_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

z_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

x_abs.$(SUFFIX) : abs.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

slamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

dlamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

qlamch.$(SUFFIX) : lamch.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

slamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

dlamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -DDOUBLE $< -o $(@F)

qlamc3.$(SUFFIX) : lamc3.c
	$(CC) $(CFLAGS) -c -DXDOUBLE $< -o $(@F)

divtable.$(SUFFIX) : divtable.c
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

__builtin_stinit.$(SUFFIX) : $(ARCH)/builtin_stinit.S
	$(CC) $(CFLAGS) -c -UDOUBLE $< -o $(@F)

addx.$(SUFFIX) : $(ARCH)/addx.c
	$(CC) $(CFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

mulx.$(SUFFIX) : $(ARCH)/mulx.c
	$(CC) $(CFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

xerbla.$(PSUFFIX) : xerbla.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

parameter.$(PSUFFIX) : parameter.c ../../param.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

init.$(PSUFFIX) : init.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

profile.$(PSUFFIX) : profile.c
	$(CC) $(PFLAGS) -c $< -o $(@F)

memory.$(PSUFFIX) : $(MEMORY) ../../common.h ../../param.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

blas_server.$(PSUFFIX) : $(BLAS_SERVER) ../../common.h ../../common_thread.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

blasL1thread.$(PSUFFIX) : blas_l1_thread.c ../../common.h ../../common_thread.h
	$(CC) $(PFLAGS) -c $< -o $(@F)

cuda_init.$(PSUFFIX) : cuda_init.c
	$(CUCC) $(COMMON_OPT) -I$(TOPDIR) $(CUFLAGS) -DCNAME=$(*F) -c $< -o $(@F)

c_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

z_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

x_abs.$(PSUFFIX) : abs.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

slamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

dlamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

qlamch.$(PUFFIX) : lamch.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

slamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

dlamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -DDOUBLE $< -o $(@F)

qlamc3.$(PUFFIX) : lamc3.c
	$(CC) $(PFLAGS) -c -DXDOUBLE $< -o $(@F)

divtable.$(PSUFFIX) : divtable.c
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

__builtin_stinit.$(PPSUFFIX) : $(ARCH)/builtin_stinit.S
	$(CC) $(PFLAGS) -c -UDOUBLE $< -o $(@F)

addx.$(PSUFFIX) : $(ARCH)/addx.c
	$(CC) $(PFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

mulx.$(PSUFFIX) : $(ARCH)/mulx.c
	$(CC) $(PFLAGS) -c -DXDOUBLE -UCOMPLEX $< -o $(@F)

info.$(SUFFIX) : info.c info.h ../../common.h ../../param.h
	$(CC) $(CFLAGS) -c $< -o $(@F)


hpl   : override CFLAGS += -DHPL
hpl_p : override CFLAGS += -DHPL

include $(TOPDIR)/Makefile.tail

=== debian/changelog ===
openblas (0.2.5-1~exp1) experimental; urgency=low

  [ Sébastien Villemot ]
  * Update debian/watch
  * Use my @debian.org email address
  * Remove obsolete DM-Upload-Allowed flag

  [ Sylvestre Ledru ]
  * New upstream release
  * generic_profile.diff removed (applied upstream)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 08 Dec 2012 16:24:30 +0100

openblas (0.2.4-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 15 Oct 2012 20:15:49 +0200

openblas (0.2.3-1~exp1) experimental; urgency=low

  * New upstream release
    + Kills threads when unloading the library (Closes: #673061)

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Mon, 20 Aug 2012 12:18:07 +0000

openblas (0.2.2-1~exp1) experimental; urgency=low

  * New upstream release
  * hurd.diff, hurd_gettid.diff, kfreebsd.diff, sparc.diff: remove patches,
    applied upstream
  * debian/rules: implement support for DEB_BUILD_OPTIONS=noopt

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Wed, 11 Jul 2012 16:32:27 +0000

openblas (0.2.1-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 02 Jul 2012 02:24:00 +0200

=== debian/rules ===
#!/usr/bin/make -f
# Sylvestre Ledru <sylvestre@debian.org>

include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_MAKESHLIBS_ARGS_libopenblas-base = -n

COMMON_MAKE_OPTIONS = "NO_LAPACK=1"
ENABLE_DYNAMIC_ARCHS := amd64 i386 kfreebsd-amd64 kfreebsd-i386
ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
	DYNAMIC_ARCH_ARG="DYNAMIC_ARCH=1"
	TARGET_GENERIC_ARG="TARGET=GENERIC"
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	DEBUG_ARG="DEBUG=1"
endif

build: build-arch

build-arch: build-stamp

build-stamp:
	if test "$(TARGET)" = ""; then 		\
			echo "Support multiple architectures"; \
			$(MAKE) $(COMMON_MAKE_OPTIONS) $(DYNAMIC_ARCH_ARG) $(TARGET_GENERIC_ARG) $(DEBUG_ARG);		\
	fi

	if test "$(TARGET)" = "custom"; then 		\
			echo "Leave the detection to GotoBLAS / OpenBLAS"; \
			$(MAKE) $(COMMON_MAKE_OPTIONS) $(DEBUG_ARG); 								\
	fi

	if test "$(TARGET)" != "" -a "$(TARGET)" != "custom"; then 		\
			echo "Use the value '$(TARGET)' provided by the user";	\
			$(MAKE) $(COMMON_MAKE_OPTIONS) TARGET=$(TARGET) $(DEBUG_ARG);									\
	fi;

	rm libopenblas.so
	mv libopenblas*-*.so libopenblas.so.0
	ln -s libopenblas.so.0 libopenblas.so
	mv libopenblas*-*.a libopenblas.a
	touch $@

custom: custom-stamp
	dch --local='+custom'  "custom build on: `uname -a`"
	LANG=C debian/rules TARGET=custom build binary

clean::
	$(MAKE) clean
	rm -f libopenblas.so.0

# Build a custom package optimized for the current arch
custom-stamp:

get-orig-source:
	-uscan --upstream-version 0

## openblas 0.2.6

=== Makefile ===
--- 
+++ 
@@ -314,7 +314,7 @@
 #endif
 	@$(MAKE) -C reference clean
 	@rm -f *.$(LIBSUFFIX) *.so *~ *.exe getarch getarch_2nd *.dll *.lib *.$(SUFFIX) *.dwf $(LIBPREFIX).$(LIBSUFFIX) $(LIBPREFIX)_p.$(LIBSUFFIX) $(LIBPREFIX).so.$(MAJOR_VERSION) *.lnk myconfig.h
-	@rm -f Makefile.conf config.h Makefile_kernel.conf config_kernel.h st* *.dylib
+	@rm -f Makefile.conf config.h cblas_noconst.h Makefile_kernel.conf config_kernel.h st* *.dylib
 	@if test -d $(NETLIB_LAPACK_DIR); then \
 	echo deleting $(NETLIB_LAPACK_DIR); \
 	rm -rf $(NETLIB_LAPACK_DIR) ;\

=== exports/Makefile ===
--- 
+++ 
@@ -21,6 +21,11 @@
 ifeq ($(OSNAME), WINNT)
 ifeq ($(F_COMPILER), GFORTRAN)
 EXTRALIB += -lgfortran
+endif
+ifeq ($(USE_OPENMP), 1)
+ifeq ($(C_COMPILER), GCC)
+EXTRALIB += -lgomp
+endif
 endif
 endif

=== driver/others/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 TOPDIR	= ../..
 include ../../Makefile.system
 
-COMMONOBJS	 = memory.$(SUFFIX) xerbla.$(SUFFIX) c_abs.$(SUFFIX) z_abs.$(SUFFIX) openblas_set_num_threads.$(SUFFIX)
+COMMONOBJS	 = memory.$(SUFFIX) xerbla.$(SUFFIX) c_abs.$(SUFFIX) z_abs.$(SUFFIX) openblas_set_num_threads.$(SUFFIX) openblas_get_config.$(SUFFIX)
 
 COMMONOBJS	+= slamch.$(SUFFIX) slamc3.$(SUFFIX) dlamch.$(SUFFIX)  dlamc3.$(SUFFIX)
 
@@ -103,6 +103,9 @@
 openblas_set_num_threads.$(SUFFIX) : openblas_set_num_threads.c
 	$(CC) $(CFLAGS) -c $< -o $(@F)
 
+openblas_get_config.$(SUFFIX) : openblas_get_config.c
+	$(CC) $(CFLAGS) -c $< -o $(@F)
+
 blasL1thread.$(SUFFIX) : blas_l1_thread.c ../../common.h ../../common_thread.h
 	$(CC) $(CFLAGS) -c $< -o $(@F)

=== debian/changelog ===
openblas (0.2.6-1~exp1) experimental; urgency=low

  * New upstream release
    + Fixes use of uninitialized values in vectorized sgemv on i386.
      (Closes: #696000)
    + Fixes the overflowing buffer bug of gemv. (Closes: #697231)
    + Fixes the the overflowing buffer bug of multithreading hbmv and sbmv.
      (Closes: #697232)
    + Fixes crash on 32-bit Athlon CPUs. (Closes: #697233)
    + Better handling of unknown amd64 CPUs (e.g. within qemu).
      (Closes: #697235)
  * Disable processor affinity. (Closes: #684338)
  * Force the maximum number of threads to 2 when building the generic package
    (as we do for ATLAS). Otherwise, it is the number of cores on the build
    machine which is chosen instead.
  * README.Debian: improve instructions for building the custom package

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 02 Mar 2013 15:09:09 +0100

=== debian/control ===
Source: openblas
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
           Sébastien Villemot <sebastien@debian.org>
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), patch, cdbs, gfortran
Homepage: https://github.com/xianyi/OpenBLAS
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/openblas/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/openblas/

Package: libopenblas-base
Section: libs
Architecture: amd64 i386 ia64 powerpc powerpcspe ppc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 sparc
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libblas.so.3
Suggests: liblapack3
Replaces: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4)
Breaks: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4)
Description: Optimized BLAS (linear algebra) library based on GotoBLAS2
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched
 the best architecutre at run time.
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

Package: libopenblas-dev
Section: libdevel
Architecture: amd64 i386 ia64 powerpc powerpcspe ppc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 sparc
Depends: libopenblas-base (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: libblas.so
Suggests: liblapack-dev
Description: Optimized BLAS (linear algebra) library based on GotoBLAS2
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched
 the best architecutre at run time.
 .
 This package includes the static libraries and symbolic links
 needed for program development.

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 DEB_DH_MAKESHLIBS_ARGS_libopenblas-base = -n
 
-COMMON_MAKE_OPTIONS = "NO_LAPACK=1"
+COMMON_MAKE_OPTIONS = NO_LAPACK=1 NO_AFFINITY=1
 ENABLE_DYNAMIC_ARCHS := amd64 i386 kfreebsd-amd64 kfreebsd-i386
 ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
 	DYNAMIC_ARCH_ARG="DYNAMIC_ARCH=1"
@@ -23,7 +23,7 @@
 build-stamp:
 	if test "$(TARGET)" = ""; then 		\
 			echo "Support multiple architectures"; \
-			$(MAKE) $(COMMON_MAKE_OPTIONS) $(DYNAMIC_ARCH_ARG) $(TARGET_GENERIC_ARG) $(DEBUG_ARG);		\
+			$(MAKE) $(COMMON_MAKE_OPTIONS) $(DYNAMIC_ARCH_ARG) $(TARGET_GENERIC_ARG) $(DEBUG_ARG) NUM_THREADS=2;		\
 	fi
 
 	if test "$(TARGET)" = "custom"; then 		\
